SystemOrganization addCategory: #ConfigurationOfFFI!

Object subclass: #ConfigurationOfFFI
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfFFI'!

!ConfigurationOfFFI class methodsFor: 'private' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfFFI class methodsFor: 'private' stamp: 'DaleHenrichs 1/6/2010 16:45'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfFFI class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfFFI class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfFFI class methodsFor: 'loading' stamp: 'tbn 5/14/2010 11:12'!
load
	^self project latestVersion load! !

!ConfigurationOfFFI class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfFFI class methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
project

	^self new project! !

!ConfigurationOfFFI methodsFor: 'baselines' stamp: 'tbn 2/22/2010 01:18'!
baseline10: spec
    <version: '1.0-baseline'>
    
    spec for: #squeakCommon do: [
        spec blessing: #baseline.
        spec description: 'FFI-Examples removed from repository!!'.
        spec repository: 'http://source.squeakfoundation.org/FFI'.
        
        spec package: 'FFI-Pools'.
        spec package: 'FFI-Kernel'.
        spec package: 'FFI-Tests'.
        spec package: 'FFI-Examples' with: [ 
            spec postLoadDoIt: #ffiExampleInitialization10 ] ]
        
! !

!ConfigurationOfFFI methodsFor: 'baselines' stamp: 'MarianoMartinezPeck 2/14/2010 22:58'!
baseline12: spec
	<version: '1.2-baseline'>
    
	spec for: #squeakCommon do: [
		spec blessing: #baseline.
		spec repository: 'http://source.squeakfoundation.org/FFI'.
		spec postLoadDoIt: #ffiExampleInitialization10.
        
		spec package: 'FFI-Pools'.
		spec package: 'FFI-Kernel'.
		spec package: 'FFI-Tests'.
		spec package: 'FFI-MacOS'.
		spec package: 'FFI-Unix'.
		spec package: 'FFI-Win32'. 

	]
        
! !

!ConfigurationOfFFI methodsFor: 'doits' stamp: 'EstebanLorenzano 12/7/2009 22:49'!
ffiExampleInitialization10
	(Smalltalk at: #ExternalType) initialize.
	(Smalltalk at: #ExternalStructure) compileAllFields.
	Smalltalk recreateSpecialObjectsArray! !

!ConfigurationOfFFI methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'DaleHenrichs 2/16/2010 20:57'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #broken.
      	spec description: 'FFI-Examples removed from repository!!'.
  		
		spec package: 'FFI-Pools' with: 'FFI-Pools-ar.1'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-ar.12'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-ar.3'.
		spec package: 'FFI-Examples' with: 'FFI-Examples-ar.1' ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'tbn 2/22/2010 01:18'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
     	spec description: 'FFI-Examples removed from repository!!'.
 		
		spec package: 'FFI-Pools' with: 'FFI-Pools-ar.1'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-ar.13'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-ar.3'.
		spec package: 'FFI-Examples' with: 'FFI-Examples-ar.1' ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'tbn 5/14/2010 11:23'!
version12: spec
	<version: '1.2' imports: #('1.2-baseline')>
	
	spec for: #common do: [
		spec blessing: #development.
		spec description: '- Remove the Examples package
		- Added postLoadDoIt to project level'.
		
		spec package: 'FFI-Pools' with: 'FFI-Pools-ar.1'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-ar.13'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-ar.3'.
		spec package: 'FFI-MacOS' with: 'FFI-MacOS-ar.3'.
		spec package: 'FFI-Unix' with: 'FFI-Unix-tbn.2'.
		spec package: 'FFI-Win32' with: 'FFI-Win32-ar.3'. 
		
		 ]! !
